package net.wanji.opt.synthesis.service.impl;

import com.fasterxml.jackson.databind.ObjectMapper;
import lombok.extern.slf4j.Slf4j;
import net.wanji.common.tool.resttool.RestTemplateTool;
import net.wanji.common.utils.tool.JacksonUtils;
import net.wanji.opt.synthesis.pojo.Result;
import net.wanji.opt.synthesis.pojo.StrategyControlReq;
import net.wanji.opt.synthesis.service.PushStrategyControlService;
import org.springframework.stereotype.Service;
import org.springframework.util.StringUtils;

import java.util.Objects;

/**
 * @author duanruiming
 * @date 2024/11/03 16:25
 */
@Service
@Slf4j
public class PushStrategyControlServiceImpl implements PushStrategyControlService {

    @Override
    public void insert() {

    }

    @Override
    public void update() {

    }

    @Override
    public void delete() {

    }

    @Override
    public Result push(StrategyControlReq req) throws Exception {
        String url = "";
        try {
            ObjectMapper mapper = JacksonUtils.getInstance();
            String resultStr = RestTemplateTool.post(url, mapper.writeValueAsString(req));
            Result result = mapper.readValue(resultStr, Result.class);
            if (Objects.nonNull(result)) {
                if (StringUtils.endsWithIgnoreCase("200", result.getCode())) {
                    return result;
                }
                return result;
            } else {
                log.error("策略推送url:{}失败：返回数据异常", url);
                return new Result("500", "服务调用失败", null);
            }
        } catch (Exception e) {
            log.error("策略控制推送url:{}，失败：{}", url, e);
            throw new Exception(e);
        }
    }
}
